## primesieve 7.3+ds

=== doc/CMakeLists.txt ===
find_package(Doxygen)

if(DOXYGEN_FOUND)
    find_package(LATEX)
    find_program(DOT_FONUD dot)

    if(LATEX_COMPILER)
        set(HAVE_LATEX "YES")
    else()
        set(HAVE_LATEX "NO")
    endif()

    if(DOT_FONUD)
        message(STATUS "Found dot (graphviz): ${DOT_FONUD}")
        set(HAVE_DOT "YES")
    else()
        set(HAVE_DOT "NO")
    endif()

    configure_file(Doxyfile.in Doxyfile @ONLY)
    add_custom_target(doc COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile)

    if(LATEX_COMPILER)
        find_program(MAKE_FONUD make)

        # LaTeX doc (PDF) must be built using make
        if(MAKE_FONUD)
            add_custom_command(TARGET doc
                               POST_BUILD
                               COMMAND "${MAKE_FONUD}"
                               WORKING_DIRECTORY "latex")
        endif()
    endif()
endif()

=== test/CMakeLists.txt ===
enable_language(C)
file(GLOB files "*.cpp" "*.c")

foreach(file ${files})
    get_filename_component(binary_name ${file} NAME_WE)
    add_executable(${binary_name} ${file})
    target_link_libraries(${binary_name} primesieve::primesieve)
    add_test(NAME ${binary_name} COMMAND ${binary_name})
endforeach()

=== debian/changelog ===
primesieve (7.3+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - debian/{copyright,adhoc/c{,pp}/Makefile}:
      - Copyright year tuple, update;
    - debian/control:
      - Standards Version, bump to 4.3.0 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 17 Jan 2019 14:39:34 +0000

primesieve (7.2+ds-1) unstable; urgency=medium

  * New upstream minor release.

 -- Jerome Benoit <calculus@rezozer.net>  Wed, 31 Oct 2018 03:11:41 +0000

primesieve (7.1+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - debian/control:
      - Standards Version, bump to 4.2.1 (no change);
    - debian/tests/*:
      - d/t/make-check-dev , update;
    - debian/clean , refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 22 Sep 2018 14:56:54 +0000

=== debian/control ===
Source: primesieve
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jerome Benoit <calculus@rezozer.net>
Section: math
Priority: optional
Build-Depends:
 debhelper (>= 11),
 cmake, help2man
Build-Depends-Indep:
 doxygen, doxygen-latex, graphviz,
 rdfind, symlinks
Standards-Version: 4.3.0
Vcs-Git: https://salsa.debian.org/science-team/primesieve.git
Vcs-Browser: https://salsa.debian.org/science-team/primesieve
Homepage: https://primesieve.org/

Package: primesieve
Architecture: any
Depends: primesieve-bin, ${misc:Depends}
Description: fast prime number generator C/C++ library
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This dummy package provides the standard installation.

Package: libprimesieve9
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: primesieve-bin (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Conflicts: libprimesieve
Provides: libprimesieve
Description: fast prime number generator C/C++ library -- lib
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the shared library.

Package: libprimesieve-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libprimesieve9 (= ${binary:Version}), libprimesieve-dev-common (= ${source:Version}),
 ${misc:Depends}
Suggests: primesieve-doc (= ${source:Version}), pkg-config
Conflicts: libprimesieve-dev
Provides: libprimesieve-dev
Description: fast prime number generator C/C++ library -- libdev
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the static library and symbolic links needed
 for development.

Package: libprimesieve-dev-common
Architecture: all
Multi-Arch: foreign
Replaces: libprimesieve7-dev-common
Breaks: libprimesieve7-dev-common
Section: libdevel
Depends: ${misc:Depends}
Recommends: libprimesieve-dev (= ${binary:Version})
Provides: libprimesieve-dev-common
Description: fast prime number generator C/C++ library -- headers
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the headers needed by developers.

Package: primesieve-bin
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: primesieve-doc (= ${source:Version})
Description: fast prime number generator C/C++ library -- bin
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the command line utility primesieve.

Package: primesieve-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-jquery, ${misc:Depends}
Suggests: pdf-viewer, www-browser
Enhances: primesieve-bin (= ${binary:Version}), libprimesieve-dev (= ${binary:Version})
Description: fast prime number generator C/C++ library -- doc
 primesieve is a free software program and C/C++ library that generates
 primes using a highly optimized sieve of Eratosthenes implementation.
 primesieve can generate primes and prime k-tuplets up to nearly 2^64.
 .
 See http://primesieve.org/ for more information.
 .
 This package provides the API documentation with its concomitant examples.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

## inspired from mpfr material
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS    += -O0
	CXXCFLAGS += -O0
else ifeq ($(DEB_HOST_ARCH),alpha)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else ifeq ($(DEB_HOST_ARCH),sha4)
	CFLAGS   += -mieee
	CXXFLAGS += -mieee
else
	CFLAGS   := $(subst -O2,-O3,$(CFLAGS))
	CXXFLAGS := $(subst -O2,-O3,$(CXXFLAGS))
endif

default:
	@uscan --no-conf --dehs --report || true

%:
	dh $@ --builddirectory=_build

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_TESTS=ON \
		-DBUILD_EXAMPLES=ON \
		-DBUILD_DOC=ON

override_dh_auto_build-indep: README.implementation.md
	$(MAKE) -f debian/adhoc/Makefile doc

override_dh_auto_test-indep:
	true

override_dh_prep-arch: README.implementation.md

override_dh_auto_install-indep:
	DESTDIR=$(CURDIR)/debian/tmp $(CMAKE) \
			-DCMAKE_INSTALL_COMPONENT=libprimesieve-headers \
		-P _build/cmake_install.cmake

override_dh_installdocs:
	dh_installdocs -pprimesieve-bin    --link-doc=libprimesieve9
	dh_installdocs -plibprimesieve-dev --doc-main-package=libprimesieve-dev-common
	dh_installdocs --remaining-packages

override_dh_installexamples-indep:
	dh_installexamples -XCMakeLists.txt -XREADME.md

override_dh_compress-indep:
	dh_compress -X.pdf -Xexamples

README.implementation.md:
	cp -p src/README.md README.implementation.md

CMAKE ?= cmake

=== debian/tests/control ===
Tests: make-check-bin
Depends: primesieve-bin

Tests: make-check-dev
Depends: libprimesieve-dev, build-essential, pkg-config

Tests: build-examples
Depends: primesieve-doc, libprimesieve-dev, build-essential, pkg-config

## primesieve 7.4+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(primesieve CXX)
set(PRIMESIEVE_VERSION "7.4")
set(PRIMESIEVE_SOVERSION "9.4.0")

# Build options ######################################################

option(BUILD_PRIMESIEVE  "Build primesieve binary"    ON)
option(BUILD_SHARED_LIBS "Build shared libprimesieve" ON)
option(BUILD_STATIC_LIBS "Build static libprimesieve" ON)
option(BUILD_DOC         "Build documentation"        OFF)
option(BUILD_EXAMPLES    "Build example programs"     OFF)
option(BUILD_TESTS       "Build test programs"        OFF)

if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
    message(FATAL_ERROR "One or both of BUILD_SHARED_LIBS or BUILD_STATIC_LIBS must be set to ON")
endif()

# Set default build type to Release ##################################

if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.9)
    get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
elseif(CMAKE_CONFIGURATION_TYPES)
    set(isMultiConfig TRUE)
endif()

if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# primesieve binary source files #####################################

set(BIN_SRC src/console/cmdoptions.cpp
            src/console/help.cpp
            src/console/main.cpp
            src/console/test.cpp)

# primesieve library source files ####################################

set(LIB_SRC src/api-c.cpp
            src/api.cpp
            src/CpuInfo.cpp
            src/EratBig.cpp
            src/EratMedium.cpp
            src/EratSmall.cpp
            src/iterator-c.cpp
            src/iterator.cpp
            src/IteratorHelper.cpp
            src/MemoryPool.cpp
            src/PrimeGenerator.cpp
            src/nthPrime.cpp
            src/ParallelSieve.cpp
            src/popcount.cpp
            src/PreSieve.cpp
            src/PrintPrimes.cpp
            src/PrimeSieve.cpp
            src/Erat.cpp
            src/SievingPrimes.cpp
            src/Wheel.cpp)

# Required includes ##################################################

include(GNUInstallDirs)
include(CMakePushCheckState)
include(CheckCXXCompilerFlag)
include(CheckCXXSourceCompiles)
include(CMakePackageConfigHelpers)

# MSVC DLL support (Windows) #########################################

if(WIN32 AND NOT MINGW)
    set(WIN32_MSVC_COMPATIBLE ON)
    if(BUILD_SHARED_LIBS)
        # Export symbols to .def file
        set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    endif()
endif()

# Silence GCC switch fall through warnings ###########################

check_cxx_compiler_flag(-Wno-implicit-fallthrough Wno_fallthrough)

if(Wno_fallthrough)
    set_source_files_properties(src/EratSmall.cpp PROPERTIES COMPILE_FLAGS -Wno-implicit-fallthrough)
    set_source_files_properties(src/EratMedium.cpp PROPERTIES COMPILE_FLAGS -Wno-implicit-fallthrough)
endif()

# Check if libatomic is needed #######################################

cmake_push_check_state()

if(CMAKE_CXX11_STANDARD_COMPILE_OPTION)
    set(CMAKE_REQUIRED_FLAGS ${CMAKE_CXX11_STANDARD_COMPILE_OPTION})
endif()

check_cxx_source_compiles("
    #include <atomic>
    #include <stdint.h>
    int main() {
        std::atomic<int64_t> x;
        x = 1;
        x--;
        return (int) x;
    }"
    atomic64)

if(NOT atomic64)
    find_library(ATOMIC NAMES atomic libatomic.so.1)

    if(ATOMIC)
        set(LIBATOMIC ${ATOMIC})
        message(STATUS "Found libatomic: ${LIBATOMIC}")
    else()
        check_cxx_source_compiles("
            #include <atomic>
            #include <stdint.h>
            int main() {
                std::atomic<int32_t> x;
                x = 1;
                x--;
                return (int) x;
            }"
            atomic32)

        if(atomic32)
            message(FATAL_ERROR "Failed to find libatomic!")
        endif()
    endif()
endif()

cmake_pop_check_state()

# libprimesieve (shared library) #####################################

find_package(Threads REQUIRED QUIET)

if(BUILD_SHARED_LIBS)
    add_library(libprimesieve SHARED ${LIB_SRC})
    set_target_properties(libprimesieve PROPERTIES OUTPUT_NAME primesieve)
    target_link_libraries(libprimesieve PRIVATE Threads::Threads ${LIBATOMIC})
    string(REPLACE "." ";" SOVERSION_LIST ${PRIMESIEVE_SOVERSION})
    list(GET SOVERSION_LIST 0 PRIMESIEVE_SOVERSION_MAJOR)
    set_target_properties(libprimesieve PROPERTIES SOVERSION ${PRIMESIEVE_SOVERSION_MAJOR})
    set_target_properties(libprimesieve PROPERTIES VERSION ${PRIMESIEVE_SOVERSION})

    if(WIN32_MSVC_COMPATIBLE)
        # On Windows the shared library will be named primesieve.dll
        # and the associated import library will be named
        # primesieve.lib. This is an issue as the static library
        # is also named primesieve.lib. Hence we rename the import
        # library to primesieve.dll.lib. The Rust programming
        # language uses the same naming convention.
        set_target_properties(libprimesieve PROPERTIES IMPORT_SUFFIX ".dll.lib")
    endif()

    target_compile_features(libprimesieve
    PUBLIC
        cxx_alias_templates
    PRIVATE
        cxx_constexpr
        cxx_uniform_initialization
        cxx_lambdas)

    target_include_directories(libprimesieve PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

    install(TARGETS libprimesieve
            EXPORT primesieveShared
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# libprimesieve-static ###############################################

if(BUILD_STATIC_LIBS)
    add_library(libprimesieve-static STATIC ${LIB_SRC})
    set_target_properties(libprimesieve-static PROPERTIES OUTPUT_NAME primesieve)
    target_link_libraries(libprimesieve-static PRIVATE Threads::Threads ${LIBATOMIC})

    if(TARGET libprimesieve)
        add_dependencies(libprimesieve-static libprimesieve)
    endif()

    target_compile_features(libprimesieve-static
    PUBLIC
        cxx_alias_templates
    PRIVATE
        cxx_constexpr
        cxx_uniform_initialization
        cxx_lambdas)

    target_include_directories(libprimesieve-static PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

    install(TARGETS libprimesieve-static
            EXPORT primesieveStatic
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# Static or shared linking ###########################################

# On Unix-like OSes we use shared linking against libprimesieve by
# default mainly because this is required by Linux distributions.
# On Windows we use static linking by default because the library's
# path is not encoded into the binary. This means that the binary
# will only work if the DLL is in the same directory or a directory
# that is in the PATH environment variable.

if(WIN32 AND TARGET libprimesieve-static)
    set(STATIC_LINKING ON)
elseif(NOT TARGET libprimesieve)
    set(STATIC_LINKING ON)
endif()

if(STATIC_LINKING)
    add_library(primesieve::primesieve ALIAS libprimesieve-static)
else()
    add_library(primesieve::primesieve ALIAS libprimesieve)
endif()

# primesieve binary ##################################################

if(BUILD_PRIMESIEVE)
    add_executable(primesieve ${BIN_SRC})
    target_link_libraries(primesieve primesieve::primesieve)
    target_compile_features(primesieve PRIVATE cxx_auto_type)
    install(TARGETS primesieve DESTINATION ${CMAKE_INSTALL_BINDIR})

    if(TARGET libprimesieve-static)
        add_dependencies(primesieve libprimesieve-static)
    endif()
endif()

# Install headers ####################################################

install(FILES include/primesieve.h
              include/primesieve.hpp
              COMPONENT libprimesieve-headers
              DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(FILES include/primesieve/iterator.h
              include/primesieve/iterator.hpp
              include/primesieve/StorePrimes.hpp
              include/primesieve/primesieve_error.hpp
              COMPONENT libprimesieve-headers
              DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/primesieve)

# CMake find_package(primesieve) support #############################

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/primesieveConfigVersion.cmake"
    VERSION ${PRIMESIEVE_VERSION}
    COMPATIBILITY SameMajorVersion)

configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/primesieveConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/primesieveConfig.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/primesieveConfig.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/primesieveConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")

if(TARGET libprimesieve)
    install(EXPORT primesieveShared
            NAMESPACE primesieve::
            DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")
endif()

if(TARGET libprimesieve-static)
    install(EXPORT primesieveStatic
            NAMESPACE primesieve::
            DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/primesieve")
endif()

# Regenerate man page ################################################

if(CMAKE_SYSTEM_NAME AND
   CMAKE_HOST_SYSTEM_NAME AND
   NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "${CMAKE_HOST_SYSTEM_NAME}")
    set(IS_CROSS_COMPILIATION ON)
endif()

if(CMAKE_SYSTEM_PROCESSOR AND
   CMAKE_HOST_SYSTEM_PROCESSOR AND
   NOT "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "${CMAKE_HOST_SYSTEM_PROCESSOR}")
    set(IS_CROSS_COMPILIATION ON)
endif()

if(BUILD_PRIMESIEVE AND NOT IS_CROSS_COMPILIATION)
    find_program(HELP2MAN help2man)

    if(HELP2MAN)
        message(STATUS "Found help2man: ${HELP2MAN}")

        execute_process(COMMAND perl -e "use Locale::gettext;"
                        RESULT_VARIABLE LOCALE_RES
                        OUTPUT_QUIET ERROR_QUIET)

        if(LOCALE_RES EQUAL 0)
            message(STATUS "Found help2man option: --locale=C.UTF-8")
            set(HELP2MAN_LOCALE "--locale=C.UTF-8")
        endif()

        add_custom_command(
            TARGET ${PROJECT_NAME} POST_BUILD
            COMMAND ${HELP2MAN}
            ARGS -s 1
                 --manual="primesieve"
                 --source="primesieve ${PRIMESIEVE_VERSION}"
                 --no-info
                 ${HELP2MAN_LOCALE}
                 -n "efficient prime number generator"
                 -o ${PROJECT_SOURCE_DIR}/doc/primesieve.1
                 $<TARGET_FILE:primesieve>
            VERBATIM)
    endif()
endif()

# Install man page ###################################################

if(BUILD_PRIMESIEVE)
    install(FILES ${PROJECT_SOURCE_DIR}/doc/primesieve.1
            DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
endif()

# Install primesieve.pc (pkg-config) #################################

configure_file(primesieve.pc.in primesieve.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/primesieve.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# Add subdirectories #################################################

if(BUILD_DOC)
    add_subdirectory(doc)
endif()

if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()

=== debian/changelog ===
primesieve (7.4+ds-2ubuntu1) eoan; urgency=medium

  * Merge with Debian unstable, remaining changes:
    + Allow stderr output in autopkgtests for GCC warnings on armhf

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 16 Aug 2019 12:06:26 +0000

primesieve (7.4+ds-2) unstable; urgency=medium

  * Upload to unstable.
  * Debianization:
    - debian/control:
      - Standards Version, bump to 4.4.0 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 16 Aug 2019 05:53:41 +0000

primesieve (7.4+ds-1) experimental; urgency=medium

  * New upstream minor release.
  * Debianization:
    - debian/tests/*:
      - d/t/control, add self-test check;
    - debian/control:
      - Build-Depends, migrate to debhelper-compat (=12);
    - debian/compat, discard.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 26 Apr 2019 06:02:10 +0000

primesieve (7.3+ds-1ubuntu1) disco; urgency=medium

  * Merge with Debian unstable, remaining changes:
    + Allow stderr output in autopkgtests for GCC warnings on armhf

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 18 Jan 2019 12:19:57 +0000

primesieve (7.2+ds-1ubuntu1) disco; urgency=medium

  * Merge with Debian unstable, remaining changes:
    + Allow stderr output in autopkgtests for GCC warnings on armhf

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 12 Nov 2018 10:04:06 +0000

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: primesieve
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
 Build-Depends:
- debhelper (>= 11),
+ debhelper-compat (=12),
  cmake, help2man
 Build-Depends-Indep:
  doxygen, doxygen-latex, graphviz,
  rdfind, symlinks
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Vcs-Git: https://salsa.debian.org/science-team/primesieve.git
 Vcs-Browser: https://salsa.debian.org/science-team/primesieve
 Homepage: https://primesieve.org/

## primesieve 7.5+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,17 @@
 cmake_minimum_required(VERSION 3.4)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "7.4")
-set(PRIMESIEVE_SOVERSION "9.4.0")
+set(PRIMESIEVE_VERSION "7.5")
+set(PRIMESIEVE_SOVERSION "9.5.0")
 
 # Build options ######################################################
 
-option(BUILD_PRIMESIEVE  "Build primesieve binary"    ON)
-option(BUILD_SHARED_LIBS "Build shared libprimesieve" ON)
-option(BUILD_STATIC_LIBS "Build static libprimesieve" ON)
-option(BUILD_DOC         "Build documentation"        OFF)
-option(BUILD_EXAMPLES    "Build example programs"     OFF)
-option(BUILD_TESTS       "Build test programs"        OFF)
+option(BUILD_PRIMESIEVE  "Build primesieve binary"       ON)
+option(BUILD_SHARED_LIBS "Build shared libprimesieve"    ON)
+option(BUILD_STATIC_LIBS "Build static libprimesieve"    ON)
+option(BUILD_DOC         "Build C/C++ API documentation" OFF)
+option(BUILD_MANPAGE     "Regenerate man page using a2x" OFF)
+option(BUILD_EXAMPLES    "Build example programs"        OFF)
+option(BUILD_TESTS       "Build test programs"           OFF)
 
 if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
     message(FATAL_ERROR "One or both of BUILD_SHARED_LIBS or BUILD_STATIC_LIBS must be set to ON")
@@ -18,7 +19,7 @@
 
 # Set default build type to Release ##################################
 
-if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.9)
+if(NOT CMAKE_VERSION VERSION_LESS 3.9)
     get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
 elseif(CMAKE_CONFIGURATION_TYPES)
     set(isMultiConfig TRUE)
@@ -47,6 +48,7 @@
             src/iterator-c.cpp
             src/iterator.cpp
             src/IteratorHelper.cpp
+            src/LookupTables.cpp
             src/MemoryPool.cpp
             src/PrimeGenerator.cpp
             src/nthPrime.cpp
@@ -56,8 +58,7 @@
             src/PrintPrimes.cpp
             src/PrimeSieve.cpp
             src/Erat.cpp
-            src/SievingPrimes.cpp
-            src/Wheel.cpp)
+            src/SievingPrimes.cpp)
 
 # Required includes ##################################################
 
@@ -281,44 +282,20 @@
 
 # Regenerate man page ################################################
 
-if(CMAKE_SYSTEM_NAME AND
-   CMAKE_HOST_SYSTEM_NAME AND
-   NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "${CMAKE_HOST_SYSTEM_NAME}")
-    set(IS_CROSS_COMPILIATION ON)
-endif()
-
-if(CMAKE_SYSTEM_PROCESSOR AND
-   CMAKE_HOST_SYSTEM_PROCESSOR AND
-   NOT "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "${CMAKE_HOST_SYSTEM_PROCESSOR}")
-    set(IS_CROSS_COMPILIATION ON)
-endif()
-
-if(BUILD_PRIMESIEVE AND NOT IS_CROSS_COMPILIATION)
-    find_program(HELP2MAN help2man)
-
-    if(HELP2MAN)
-        message(STATUS "Found help2man: ${HELP2MAN}")
-
-        execute_process(COMMAND perl -e "use Locale::gettext;"
-                        RESULT_VARIABLE LOCALE_RES
-                        OUTPUT_QUIET ERROR_QUIET)
-
-        if(LOCALE_RES EQUAL 0)
-            message(STATUS "Found help2man option: --locale=C.UTF-8")
-            set(HELP2MAN_LOCALE "--locale=C.UTF-8")
-        endif()
+if(BUILD_MANPAGE)
+    find_program(A2X_EXECUTABLE a2x)
+
+    if(NOT A2X_EXECUTABLE)
+        message(FATAL_ERROR "Missing a2x program (required for man page generation)!")
+    else()
+        message(STATUS "Found a2x: ${A2X_EXECUTABLE}")
 
         add_custom_command(
             TARGET ${PROJECT_NAME} POST_BUILD
-            COMMAND ${HELP2MAN}
-            ARGS -s 1
-                 --manual="primesieve"
-                 --source="primesieve ${PRIMESIEVE_VERSION}"
-                 --no-info
-                 ${HELP2MAN_LOCALE}
-                 -n "efficient prime number generator"
-                 -o ${PROJECT_SOURCE_DIR}/doc/primesieve.1
-                 $<TARGET_FILE:primesieve>
+            COMMAND ${A2X_EXECUTABLE}
+            ARGS --format=manpage
+                 -D "${PROJECT_SOURCE_DIR}/doc"
+                 "${PROJECT_SOURCE_DIR}/doc/primesieve.txt"
             VERBATIM)
     endif()
 endif()

=== debian/changelog ===
primesieve (7.5+ds-4) unstable; urgency=medium

  * Team upload
  * Allow stderr output in autopkgtests for GCC warnings on armhf

 -- Graham Inggs <ginggs@debian.org>  Sun, 04 Oct 2020 12:44:03 +0000

primesieve (7.5+ds-3) unstable; urgency=medium

  * Debianization:
    - debian/control:
      - Build-Depends, add xmlto.

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 30 Dec 2019 20:22:15 +0000

primesieve (7.5+ds-2) unstable; urgency=medium

  * Debianization:
    - debian/control:
      - Build-Depends, replace asciidoc with asciidoc-base.

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 30 Dec 2019 16:45:54 +0000

primesieve (7.5+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - debian/copyright:
      - Source field, migrate to github upstream page;
    - debian/control:
      - Standards Version, bump to 4.4.1 (no change);
      - Build-Depends, replace help2man with asciidoc;
      - Homepage field, migrate to github upstream page;
    - debian/tests/*:
      - d/t/{make-check-{bin,dev},build-examples}, now use AUTOPKGTEST_TMP;
      - d/t/make-check-dev, refresh;
    - debian/rules:
      - override_dh_auto_configure target, add BUILD_MANPAGE=ON option;
    - debian/primesieve-doc.docs, add doc/ALGORITHMS.md

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 30 Dec 2019 13:58:13 +0000

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,19 @@
 Source: primesieve
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
 Build-Depends:
  debhelper-compat (=12),
- cmake, help2man
+ cmake,
+ asciidoc-base, xmlto
 Build-Depends-Indep:
  doxygen, doxygen-latex, graphviz,
  rdfind, symlinks
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Vcs-Git: https://salsa.debian.org/science-team/primesieve.git
 Vcs-Browser: https://salsa.debian.org/science-team/primesieve
-Homepage: https://primesieve.org/
+Homepage: https://github.com/kimwalisch/primesieve
 
 Package: primesieve
 Architecture: any

## primesieve 7.6+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-cmake_minimum_required(VERSION 3.4)
+cmake_minimum_required(VERSION 3.4...3.19)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "7.5")
-set(PRIMESIEVE_SOVERSION "9.5.0")
+set(PRIMESIEVE_VERSION "7.6")
+set(PRIMESIEVE_SOVERSION "9.6.0")
 
 # Build options ######################################################
 
@@ -32,19 +32,20 @@
 
 # primesieve binary source files #####################################
 
-set(BIN_SRC src/console/cmdoptions.cpp
-            src/console/help.cpp
-            src/console/main.cpp
-            src/console/test.cpp)
+set(BIN_SRC src/app/cmdoptions.cpp
+            src/app/help.cpp
+            src/app/main.cpp
+            src/app/test.cpp)
 
 # primesieve library source files ####################################
 
 set(LIB_SRC src/api-c.cpp
             src/api.cpp
             src/CpuInfo.cpp
+            src/Erat.cpp
+            src/EratSmall.cpp
+            src/EratMedium.cpp
             src/EratBig.cpp
-            src/EratMedium.cpp
-            src/EratSmall.cpp
             src/iterator-c.cpp
             src/iterator.cpp
             src/IteratorHelper.cpp
@@ -57,14 +58,12 @@
             src/PreSieve.cpp
             src/PrintPrimes.cpp
             src/PrimeSieve.cpp
-            src/Erat.cpp
             src/SievingPrimes.cpp)
 
 # Required includes ##################################################
 
 include(GNUInstallDirs)
 include(CMakePushCheckState)
-include(CheckCXXCompilerFlag)
 include(CheckCXXSourceCompiles)
 include(CMakePackageConfigHelpers)
 
@@ -76,15 +75,6 @@
         # Export symbols to .def file
         set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
     endif()
-endif()
-
-# Silence GCC switch fall through warnings ###########################
-
-check_cxx_compiler_flag(-Wno-implicit-fallthrough Wno_fallthrough)
-
-if(Wno_fallthrough)
-    set_source_files_properties(src/EratSmall.cpp PROPERTIES COMPILE_FLAGS -Wno-implicit-fallthrough)
-    set_source_files_properties(src/EratMedium.cpp PROPERTIES COMPILE_FLAGS -Wno-implicit-fallthrough)
 endif()
 
 # Check if libatomic is needed #######################################

=== debian/changelog ===
primesieve (7.6+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/copyright:
      - Files-Excluded list, refresh;
      - copyright year tuple, update;
      - gui Files section, discard;
      - Debian License, migrate to BSD-2-clause;
    - d/control:
      - Rules-Requires-Root, introduce and set to no;
      - Standards-Version, bump to 4.5.1 (no change);
      - multiarch medata, fix;
    - d/primesieve-doc.docs, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Tue, 19 Jan 2021 19:08:44 +0000

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
+Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (=12),
  cmake,
@@ -10,13 +11,14 @@
 Build-Depends-Indep:
  doxygen, doxygen-latex, graphviz,
  rdfind, symlinks
-Standards-Version: 4.4.1
+Standards-Version: 4.5.1
 Vcs-Git: https://salsa.debian.org/science-team/primesieve.git
 Vcs-Browser: https://salsa.debian.org/science-team/primesieve
 Homepage: https://github.com/kimwalisch/primesieve
 
 Package: primesieve
-Architecture: any
+Architecture: all
+Multi-Arch: foreign
 Depends: primesieve-bin, ${misc:Depends}
 Description: fast prime number generator C/C++ library
  primesieve is a free software program and C/C++ library that generates

=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,8 @@
 	dh_auto_configure -- \
 		-DBUILD_TESTS=ON \
 		-DBUILD_EXAMPLES=ON \
-		-DBUILD_DOC=ON
+		-DBUILD_DOC=ON \
+		-DBUILD_MANPAGE=ON
 
 override_dh_auto_build-indep: README.implementation.md
 	$(MAKE) -f debian/adhoc/Makefile doc

=== debian/watch ===
version=4
opts=repack,repacksuffix=+ds,compression=xz,dversionmangle=s/\+ds//,uversionmangle=s/-rc/~rc/,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/primesieve-$1\.tar\.gz/ \
https://github.com/kimwalisch/primesieve/releases .*/archive/v?(\d\S*)\.tar\.gz

## primesieve 7.8%2Bds

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,19 @@
 Source: primesieve
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
 Rules-Requires-Root: no
 Build-Depends:
- debhelper-compat (=12),
+ debhelper-compat (=13),
  cmake,
  asciidoc-base, xmlto
 Build-Depends-Indep:
  doxygen, doxygen-latex, graphviz,
  rdfind, symlinks
-Standards-Version: 4.5.1
-Vcs-Git: https://salsa.debian.org/science-team/primesieve.git
-Vcs-Browser: https://salsa.debian.org/science-team/primesieve
+Standards-Version: 4.6.0
+Vcs-Git: https://salsa.debian.org/math-team/primesieve.git
+Vcs-Browser: https://salsa.debian.org/math-team/primesieve
 Homepage: https://github.com/kimwalisch/primesieve
 
 Package: primesieve

## primesieve 7.8+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.19)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "7.6")
-set(PRIMESIEVE_SOVERSION "9.6.0")
+set(PRIMESIEVE_VERSION "7.8")
+set(PRIMESIEVE_SOVERSION "9.8.0")
 
 # Build options ######################################################
 
@@ -12,6 +12,10 @@
 option(BUILD_MANPAGE     "Regenerate man page using a2x" OFF)
 option(BUILD_EXAMPLES    "Build example programs"        OFF)
 option(BUILD_TESTS       "Build test programs"           OFF)
+
+option(WITH_MSVC_CRT_STATIC "Link primesieve.lib with /MT instead of the default /MD" OFF)
+
+# libprimesieve sanity check #########################################
 
 if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
     message(FATAL_ERROR "One or both of BUILD_SHARED_LIBS or BUILD_STATIC_LIBS must be set to ON")
@@ -171,6 +175,10 @@
     set_target_properties(libprimesieve-static PROPERTIES OUTPUT_NAME primesieve)
     target_link_libraries(libprimesieve-static PRIVATE Threads::Threads ${LIBATOMIC})
 
+    if(WITH_MSVC_CRT_STATIC)
+        set_target_properties(libprimesieve-static PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
+    endif()
+
     if(TARGET libprimesieve)
         add_dependencies(libprimesieve-static libprimesieve)
     endif()
@@ -223,6 +231,10 @@
     target_compile_features(primesieve PRIVATE cxx_auto_type)
     install(TARGETS primesieve DESTINATION ${CMAKE_INSTALL_BINDIR})
 
+    if(WITH_MSVC_CRT_STATIC)
+        set_target_properties(primesieve PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
+    endif()
+
     if(TARGET libprimesieve-static)
         add_dependencies(primesieve libprimesieve-static)
     endif()

=== debian/changelog ===
primesieve (7.8+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debinization:
    - d/control, migration to Debian Math Team group;
    - d/copyright:
      - copyright year tuples, update;
    - d/adhoc/examples/*/Makefile, refresh;
    - d/t/make-check-bin, update.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 05 Feb 2022 11:20:07 +0000

primesieve (7.7+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/control:
      - debhelper, bump to 13;
    - d/upstream/metadata, introduce.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 11 Dec 2021 14:51:52 +0000

primesieve (7.6+ds-4) unstable; urgency=medium

  * Debianization:
    - d/libprimesieve-dev.install, now install cmake material (thanks to
      Julien Schueller for noticing);
    - d/control:
      - Standards-Version, bump to 4.6.0 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 11 Oct 2021 11:01:23 +0000

primesieve (7.6+ds-3) unstable; urgency=medium

  * Upload to unstable.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 29 Aug 2021 15:33:56 +0000

primesieve (7.6+ds-2) experimental; urgency=medium

  * Debianization
    - d/watch, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 20 Jun 2021 11:49:35 +0000

=== debian/tests/control ===
Test-command: primesieve --test

Tests: make-check-bin
Depends: primesieve-bin

Tests: make-check-dev
Depends: libprimesieve-dev, build-essential, pkg-config
Restrictions: allow-stderr

Tests: build-examples
Depends: primesieve-doc, libprimesieve-dev, build-essential, pkg-config

=== debian/watch ===
version=4
opts=repack,repacksuffix=+ds,compression=xz,dversionmangle=s/\+ds//,uversionmangle=s/-rc/~rc/,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/primesieve-$1\.tar\.gz/ \
https://github.com/kimwalisch/primesieve/releases .*/archive/refs/tags/v?(\d\S*)\.tar\.gz

## primesieve 8.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-cmake_minimum_required(VERSION 3.4...3.19)
+cmake_minimum_required(VERSION 3.4...3.22)
 project(primesieve CXX)
-set(PRIMESIEVE_VERSION "7.8")
-set(PRIMESIEVE_SOVERSION "9.8.0")
+set(PRIMESIEVE_VERSION "8.0")
+set(PRIMESIEVE_SOVERSION "10.0.0")
 
 # Build options ######################################################
 
@@ -13,6 +13,7 @@
 option(BUILD_EXAMPLES    "Build example programs"        OFF)
 option(BUILD_TESTS       "Build test programs"           OFF)
 
+option(WITH_MULTIARCH       "Enable runtime dispatching to fastest supported CPU instruction set" ON)
 option(WITH_MSVC_CRT_STATIC "Link primesieve.lib with /MT instead of the default /MD" OFF)
 
 # libprimesieve sanity check #########################################
@@ -45,6 +46,7 @@
 
 set(LIB_SRC src/api-c.cpp
             src/api.cpp
+            src/CountPrintPrimes.cpp
             src/CpuInfo.cpp
             src/Erat.cpp
             src/EratSmall.cpp
@@ -60,15 +62,12 @@
             src/ParallelSieve.cpp
             src/popcount.cpp
             src/PreSieve.cpp
-            src/PrintPrimes.cpp
             src/PrimeSieve.cpp
             src/SievingPrimes.cpp)
 
 # Required includes ##################################################
 
 include(GNUInstallDirs)
-include(CMakePushCheckState)
-include(CheckCXXSourceCompiles)
 include(CMakePackageConfigHelpers)
 
 # MSVC DLL support (Windows) #########################################
@@ -81,50 +80,16 @@
     endif()
 endif()
 
-# Check if libatomic is needed #######################################
-
-cmake_push_check_state()
-
-if(CMAKE_CXX11_STANDARD_COMPILE_OPTION)
-    set(CMAKE_REQUIRED_FLAGS ${CMAKE_CXX11_STANDARD_COMPILE_OPTION})
-endif()
-
-check_cxx_source_compiles("
-    #include <atomic>
-    #include <stdint.h>
-    int main() {
-        std::atomic<int64_t> x;
-        x = 1;
-        x--;
-        return (int) x;
-    }"
-    atomic64)
-
-if(NOT atomic64)
-    find_library(ATOMIC NAMES atomic libatomic.so.1)
-
-    if(ATOMIC)
-        set(LIBATOMIC ${ATOMIC})
-        message(STATUS "Found libatomic: ${LIBATOMIC}")
-    else()
-        check_cxx_source_compiles("
-            #include <atomic>
-            #include <stdint.h>
-            int main() {
-                std::atomic<int32_t> x;
-                x = 1;
-                x--;
-                return (int) x;
-            }"
-            atomic32)
-
-        if(atomic32)
-            message(FATAL_ERROR "Failed to find libatomic!")
-        endif()
-    endif()
-endif()
-
-cmake_pop_check_state()
+# Check if libatomic is needed (old 32-bit systems) ##################
+
+include("${PROJECT_SOURCE_DIR}/cmake/libatomic.cmake")
+
+# Check if compiler supports x64 multiarch ###########################
+
+if(WITH_MULTIARCH)
+    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_popcnt_bmi.cmake")
+    include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512.cmake")
+endif()
 
 # libprimesieve (shared library) #####################################
 
@@ -139,6 +104,16 @@
     set_target_properties(libprimesieve PROPERTIES SOVERSION ${PRIMESIEVE_SOVERSION_MAJOR})
     set_target_properties(libprimesieve PROPERTIES VERSION ${PRIMESIEVE_SOVERSION})
 
+    if(multiarch_popcnt_bmi)
+        target_compile_definitions(libprimesieve PRIVATE "MULTIARCH_POPCNT_BMI")
+    endif()
+    if(multiarch_avx512)
+        target_compile_definitions(libprimesieve PRIVATE "MULTIARCH_AVX512")
+    endif()
+    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+        target_compile_definitions(libprimesieve PRIVATE "ENABLE_ASSERT")
+    endif()
+
     if(WIN32_MSVC_COMPATIBLE)
         # On Windows the shared library will be named primesieve.dll
         # and the associated import library will be named
@@ -175,6 +150,16 @@
     set_target_properties(libprimesieve-static PROPERTIES OUTPUT_NAME primesieve)
     target_link_libraries(libprimesieve-static PRIVATE Threads::Threads ${LIBATOMIC})
 
+    if(multiarch_popcnt_bmi)
+        target_compile_definitions(libprimesieve-static PRIVATE "MULTIARCH_POPCNT_BMI")
+    endif()
+    if(multiarch_avx512)
+        target_compile_definitions(libprimesieve-static PRIVATE "MULTIARCH_AVX512")
+    endif()
+    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+        target_compile_definitions(libprimesieve-static PRIVATE "ENABLE_ASSERT")
+    endif()
+
     if(WITH_MSVC_CRT_STATIC)
         set_target_properties(libprimesieve-static PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
     endif()
@@ -231,6 +216,13 @@
     target_compile_features(primesieve PRIVATE cxx_auto_type)
     install(TARGETS primesieve DESTINATION ${CMAKE_INSTALL_BINDIR})
 
+    if(multiarch_avx512)
+        target_compile_definitions(primesieve PRIVATE "MULTIARCH_AVX512")
+    endif()
+    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+        target_compile_definitions(primesieve PRIVATE "ENABLE_ASSERT")
+    endif()
+
     if(WITH_MSVC_CRT_STATIC)
         set_target_properties(primesieve PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded")
     endif()

=== debian/changelog ===
primesieve (8.0+ds-2ubuntu1) kinetic; urgency=medium

  * Merge from Debian unstable, remaining changes:
    + Allow stderr output in build-examples autopkgtest for
      GCC warnings on armhf

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 14 Jul 2022 08:31:23 +0000

primesieve (8.0+ds-2) unstable; urgency=medium

  * SBFR, sanitize d/control (Closes: #1014784).

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 11 Jul 2022 20:38:41 +0000

primesieve (8.0+ds-1) unstable; urgency=medium

  * New upstream major release, new ABI (minor changes).
  * Debianization:
    - SONAME, bump to 10;
    - d/control:
      - Standards-Version, bump to 4.6.1 (no change);
    - d/tests:
      - d/t/make-check-dev, update;
    - d/rules, harden.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 09 Jul 2022 10:45:42 +0000

primesieve (7.9+ds-1ubuntu1) kinetic; urgency=medium

  * Allow stderr output in build-examples autopkgtest for
    GCC warnings on armhf

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 10 Jun 2022 13:34:11 +0000

primesieve (7.9+ds-1) unstable; urgency=medium

  * New upstream minor release.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 08 May 2022 12:04:41 +0000

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: primesieve
-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
@@ -11,7 +12,7 @@
 Build-Depends-Indep:
  doxygen, doxygen-latex, graphviz,
  rdfind, symlinks
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/math-team/primesieve.git
 Vcs-Browser: https://salsa.debian.org/math-team/primesieve
 Homepage: https://github.com/kimwalisch/primesieve
@@ -29,15 +30,13 @@
  .
  This dummy package provides the standard installation.
 
-Package: libprimesieve9
+Package: libprimesieve10
 Architecture: any
 Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: primesieve-bin (= ${binary:Version})
 Pre-Depends: ${misc:Pre-Depends}
-Conflicts: libprimesieve
-Provides: libprimesieve
 Description: fast prime number generator C/C++ library -- lib
  primesieve is a free software program and C/C++ library that generates
  primes using a highly optimized sieve of Eratosthenes implementation.
@@ -50,13 +49,13 @@
 Package: libprimesieve-dev
 Architecture: any
 Multi-Arch: same
+Replaces: libprimesieve7-dev
+Breaks: libprimesieve7-dev
 Section: libdevel
 Depends:
- libprimesieve9 (= ${binary:Version}), libprimesieve-dev-common (= ${source:Version}),
+ libprimesieve10 (= ${binary:Version}), libprimesieve-dev-common (= ${source:Version}),
  ${misc:Depends}
 Suggests: primesieve-doc (= ${source:Version}), pkg-config
-Conflicts: libprimesieve-dev
-Provides: libprimesieve-dev
 Description: fast prime number generator C/C++ library -- libdev
  primesieve is a free software program and C/C++ library that generates
  primes using a highly optimized sieve of Eratosthenes implementation.
@@ -75,7 +74,6 @@
 Section: libdevel
 Depends: ${misc:Depends}
 Recommends: libprimesieve-dev (= ${binary:Version})
-Provides: libprimesieve-dev-common
 Description: fast prime number generator C/C++ library -- headers
  primesieve is a free software program and C/C++ library that generates
  primes using a highly optimized sieve of Eratosthenes implementation.

=== debian/rules ===
--- 
+++ 
@@ -17,11 +17,13 @@
 	CXXFLAGS := $(subst -O2,-O3,$(CXXFLAGS))
 endif
 
+BUILDDIR=_build
+
 default:
 	@uscan --no-conf --dehs --report || true
 
 %:
-	dh $@ --builddirectory=_build
+	dh $@ --builddirectory=$(BUILDDIR)
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
@@ -41,10 +43,10 @@
 override_dh_auto_install-indep:
 	DESTDIR=$(CURDIR)/debian/tmp $(CMAKE) \
 			-DCMAKE_INSTALL_COMPONENT=libprimesieve-headers \
-		-P _build/cmake_install.cmake
+		-P $(BUILDDIR)/cmake_install.cmake
 
 override_dh_installdocs:
-	dh_installdocs -pprimesieve-bin    --link-doc=libprimesieve9
+	dh_installdocs -pprimesieve-bin    --link-doc=libprimesieve10
 	dh_installdocs -plibprimesieve-dev --doc-main-package=libprimesieve-dev-common
 	dh_installdocs --remaining-packages

=== debian/tests/control ===
--- 
+++ 
@@ -9,3 +9,4 @@
 
 Tests: build-examples
 Depends: primesieve-doc, libprimesieve-dev, build-essential, pkg-config
+Restrictions: allow-stderr
